ALTER SESSION SET NLS_DATE_FORMAT = 'DD-MM-YY';

DROP TABLE EMP;
DROP TABLE DEPT;
DROP TABLE SALGRADE;
DROP TABLE EMP2; 
DROP TABLE TEMP;
DROP TABLE ERROR;
DROP TABLE SALARY;
DROP TABLE BONUS;
DROP TABLE AUDIT_TABLE;
DROP TABLE FRUITS;
DROP TABLE ORDERS;
DROP TABLE PARTS;
DROP TABLE PARTS2;
DROP TABLE TEST;
DROP TABLE TEST2;
DROP TABLE VALSAL;
DROP TABLE EMP_BY_DEPT;
DROP TABLE log_table;

drop sequence deptseq;
drop sequence new_no;
purge recyclebin;

CREATE TABLE DEPT (
 DEPTNO  NUMBER(2) NOT NULL,
 DNAME  varchar2(14),
 LOC  varchar2(13));

INSERT INTO DEPT VALUES (10,'ACCOUNTING','NEW YORK');
INSERT INTO DEPT VALUES (20,'RESEARCH','DALLAS');
INSERT INTO DEPT VALUES (30,'SALES','CHICAGO');
INSERT INTO DEPT VALUES (40,'OPERATIONS','BOSTON');

CREATE TABLE EMP (
 EMPNO  NUMBER(4) not null,
 ENAME  varchar2(10),
 JOB  varchar2(9),
 MGR  NUMBER(4),
 HIREDATE  DATE,
 SAL  NUMBER(7,2),
 COMM  NUMBER(7,2),
 DEPTNO  NUMBER(2) );

INSERT INTO EMP VALUES (7369,'SMITH','CLERK',7902,TO_DATE('17-12-1980','DD-MM-YY'),800,NULL,20);
INSERT INTO EMP VALUES (7499,'ALLEN','SALESMAN',7698,TO_DATE('20-02-1981','DD-MM-YY'),1600,300,30);
INSERT INTO EMP VALUES (7521,'WARD','SALESMAN',7698,TO_DATE('22-02-1981','DD-MM-YY'),1250,500,30);
INSERT INTO EMP VALUES (7566,'JONES','MANAGER',7839,TO_DATE('2-04-1981','DD-MM-YY'),2975,NULL,20);
INSERT INTO EMP VALUES (7654,'MARTIN','SALESMAN',7698,TO_DATE('28-09-1981','DD-MM-YY'),1250,1400,30);
INSERT INTO EMP VALUES (7698,'BLAKE','MANAGER',7839,TO_DATE('1-05-1981','DD-MM-YY'),2850,NULL,30);
INSERT INTO EMP VALUES (7782,'CLARK','MANAGER',7839,TO_DATE('9-06-1981','DD-MM-YY'),2450,NULL,10);
INSERT INTO EMP VALUES (7788,'SCOTT','ANALYST',7566,TO_DATE('09-12-1982','DD-MM-YY'),3000,NULL,20);
INSERT INTO EMP VALUES (7839,'KING','PRESIDENT',NULL,TO_DATE('17-11-1981','DD-MM-YY'),5000,NULL,10);
INSERT INTO EMP VALUES (7844,'TURNER','SALESMAN',7698,TO_DATE('8-09-1981','DD-MM-YY'),1500,0,30);
INSERT INTO EMP VALUES (7876,'ADAMS','CLERK',7788,TO_DATE('12-01-1983','DD-MM-YY'),1100,NULL,20);
INSERT INTO EMP VALUES (7900,'JAMES','CLERK',7698,TO_DATE('3-12-1981','DD-MM-YY'),950,NULL,30);
INSERT INTO EMP VALUES (7902,'FORD','ANALYST',7566,TO_DATE('3-12-1981','DD-MM-YY'),3000,NULL,20);
INSERT INTO EMP VALUES (7934,'MILLER','CLERK',7782,TO_DATE('23-01-1982','DD-MM-YY'),1300,NULL,10);

CREATE TABLE EMP2 (
 EMPNO   NUMBER(4) not null,
 ENAME   varchar2(10),
 JOB   varchar2(9),
 MGR   NUMBER(4),
 HIREDATE   DATE,
 SAL   NUMBER(7,2),
 COMM   NUMBER(7,2),
 DEPTNO   NUMBER(2) );

CREATE TABLE TEMP
(NAME VARCHAR2(10),
 SAL NUMBER);

CREATE TABLE BONUS (
 ENAME    CHAR(10),
 JOB   CHAR(9),
 SAL   NUMBER,
 COMM   NUMBER);

CREATE TABLE SALGRADE (
 GRADE   NUMBER,
 LOSAL    NUMBER,
 HISAL    NUMBER);

INSERT INTO SALGRADE VALUES (1,700,1200);
INSERT INTO SALGRADE VALUES (2,1201,1400);
INSERT INTO SALGRADE VALUES (3,1401,2000);
INSERT INTO SALGRADE VALUES (4,2001,3000);
INSERT INTO SALGRADE VALUES (5,3001,9999);

CREATE TABLE ERROR(
CODE NUMBER,
MESSAGE varchar2(200));

CREATE TABLE AUDIT_TABLE
(username  varchar2(10),
 mod_day   date,
 tablename varchar2(30),
 action    varchar2(10),
 mod_val   varchar2(20));

CREATE TABLE  salary
as select empno,sal from emp 
where 1=0;

CREATE TABLE parts
(pnum number(8),pname char(15));

CREATE TABLE  parts2
(pnum number(8),pname char(15));

DECLARE
   TYPE       numrec IS RECORD
              (no     NUMBER,
               name   VARCHAR2(20));
   TYPE       parttab IS TABLE OF numrec
                 INDEX BY PLS_INTEGER;
   parts_col  parttab;
BEGIN
   FOR i IN 1..1000000 LOOP
      parts_col(i).no := i;
      parts_col(i).name := 'No. ' || TO_CHAR(i);
   END LOOP;
         FORALL r IN 1..1000000
            INSERT INTO parts2
            VALUES (parts_col(r).no, parts_col(r).name);
END;
/

CREATE TABLE  test
(no number);

CREATE TABLE test2
(NAME VARCHAR2(10));

CREATE TABLE  valsal
(name   varchar2(10),
 oldsal number,
 newsal number,
 val    number);
 
CREATE TABLE  emp_by_dept
(empno  number,
 deptno number);

CREATE TABLE fruits 
(fruitno number(2),
 fname varchar2(15),
 price number(7,2));

insert into fruits values
(1,'APPLE',120);
insert into fruits values
(2,'ORANGE',80);
insert into fruits values
(3,'BANANA',70);
insert into fruits values
(4,'KIWI',100);
insert into fruits values
(5,'STRAWBERRY',580);
insert into fruits values
(6,'PEACH',200);
insert into fruits values
(7,'MELON',1500);
insert into fruits values
(8,'PEAR',150);
insert into fruits values
(9,'GRAPE',300);
insert into fruits values
(10,'PINEAPPLE',980);
 
CREATE TABLE orders
(solddate date,
 fruitno number(2),
 volume number(5),
 uriage number(8)
 );

CREATE TABLE LOG_TABLE
(USERNAME VARCHAR2(20),
MACHINE VARCHAR2(29),
TIME DATE);

/* 順序の作成 */
CREATE SEQUENCE deptseq
increment by 10
start with 50;

/* 付録a-10 */
CREATE SEQUENCE new_no
increment by 10
start with 50;

/* プロシージャ、ファンクション、パッケージの作成 */
CREATE OR REPLACE FUNCTION fun_depend(f_name VARCHAR2)
RETURN NUMBER
IS
     fun_no   number;
BEGIN
     SELECT sal INTO fun_no FROM emp
         WHERE ename = f_name;
     RETURN(fun_no);
END;
/

CREATE OR REPLACE PROCEDURE pro_depend(p_name VARCHAR2)
IS
     pro_no   NUMBER;
BEGIN
     pro_no := fun_depend(p_name);
     DBMS_OUTPUT.PUT_LINE(pro_no);
END;
/

CREATE OR REPLACE PACKAGE pkg_measure_change
IS
   FUNCTION fun_m_ft(m NUMBER)
   RETURN NUMBER;

   FUNCTION fun_km_mile(km NUMBER)
   RETURN NUMBER;

   num   NUMBER;
END;
/

CREATE OR REPLACE PACKAGE BODY pkg_measure_change
IS
   minus_num   exception;

   FUNCTION fun_m_ft(m NUMBER)
   RETURN NUMBER
   IS
   BEGIN
      pkg_measure_change.num := (m * 3.2808399);
         IF pkg_measure_change.num < 0 THEN RAISE minus_num;
         END IF;
      RETURN(pkg_measure_change.num);
   EXCEPTION 
      WHEN minus_num THEN RETURN(0);
   END fun_m_ft;

   FUNCTION fun_km_mile(km NUMBER)
   RETURN NUMBER
   IS
   BEGIN
      pkg_measure_change.num := (km * 0.621371192);
         IF pkg_measure_change.num < 0 THEN RAISE minus_num;
         END IF;
      RETURN(pkg_measure_change.num);
   EXCEPTION 
      WHEN minus_num THEN RETURN(0);
   END fun_km_mile;

END;
/

CREATE OR REPLACE PROCEDURE pro_check_mile(km NUMBER)
IS
   mile_hen   NUMBER;
BEGIN
   mile_hen := pkg_measure_change.fun_km_mile(km);
   DBMS_OUTPUT.PUT_LINE(mile_hen);
END;
/

/* 5章 */
CREATE OR REPLACE PACKAGE pkg_over
IS
   PROCEDURE pro_employee(name VARCHAR2);
   PROCEDURE pro_employee(eno NUMBER);
END;
/

CREATE OR REPLACE PACKAGE BODY pkg_over
IS
   no NUMBER := 0;

   PROCEDURE pro_employee(name VARCHAR2)
   IS
   BEGIN
      SELECT sal INTO no FROM emp
      WHERE ename = name;
         DBMS_OUTPUT.PUT_LINE(no);
   END pro_employee;

   PROCEDURE pro_employee(eno NUMBER)
   IS
   BEGIN
      SELECT sal INTO no FROM emp
      WHERE empno = eno;
         DBMS_OUTPUT.PUT_LINE(no);
   END pro_employee;
END;
/

/* 9章 */
CREATE OR REPLACE PROCEDURE pro_depend_over(target VARCHAR2)
IS
BEGIN
   pkg_over.pro_employee(target);
END;
/

/* 付録 */
CREATE OR REPLACE PROCEDURE pro_insert_dept(new_dname IN CHAR DEFAULT  'SE',
                                            new_loc   IN CHAR DEFAULT 'TOKYO')
IS
  no NUMBER;
BEGIN
  no := new_no.NEXTVAL;
      INSERT INTO dept
      VALUES(no,new_dname,new_loc);
END;
/


ALTER SESSION SET NLS_DATE_FORMAT = 'RR-MM-DD';
